<?php


// xml kudos: http://pear.php.net/manual/en/package.xml.xml-serializer.xml-serializer.examples.php
// curl kudos: http://webmasterjuice.com/Thread-reliable-curl-post-array-script

include("Log.php");
require_once 'XML/Serializer.php';

// create Log object
$l = &Log::singleton("file", "c:\my.log");

$currDate = date("Y-m-d H:i:s");

// Get parameters
$phoneNum = $argv[1];
$data = $argv[2];

// When FLSMS reports the senders phone number, it becomes %2B{number},
// i.e.: %2B19193604046
// So we need to sanitize this
$phoneNum = substr($phoneNum,3);

$dataArray = explode("%7C", $data);
// echo "dataArray:" .$dataArray." data:".$data;
$l->log("Current values: data:".$data, PEAR_LOG_INFO);
$reportName = $dataArray[0];
$l->log("Current values: reportName:".$reportName, PEAR_LOG_INFO);
$deviceId = $dataArray[1];
$l->log("Current values: deviceId:".$deviceId, PEAR_LOG_INFO);

// Assign data to the placeholder variables.
$A = $dataArray[2];
$l->log("Current values: A:".$A, PEAR_LOG_INFO);
$B = $dataArray[3];
$l->log("Current values: B:".$B, PEAR_LOG_INFO);
$C = $dataArray[4];
$l->log("Current values: C:".$C, PEAR_LOG_INFO);
$D = $dataArray[5];
$l->log("Current values: D:".$D, PEAR_LOG_INFO);
$E = $dataArray[6];
$l->log("Current values: E:".$E, PEAR_LOG_INFO);
$F = $dataArray[7];
$l->log("Current values: F:".$F, PEAR_LOG_INFO);
$G = $dataArray[8];
$l->log("Current values: G:".$G, PEAR_LOG_INFO);
$H = $dataArray[9];
$l->log("Current values: H:".$H, PEAR_LOG_INFO);
$I = $dataArray[10];
$l->log("Current values: I:".$I, PEAR_LOG_INFO);
$J = $dataArray[11];
$l->log("Current values: J:".$J, PEAR_LOG_INFO);
$K = $dataArray[12];
$l->log("Current values: K:".$K, PEAR_LOG_INFO);
$L = $dataArray[13];
$l->log("Current values: L:".$L, PEAR_LOG_INFO);
$M = $dataArray[14];
$l->log("Current values: M:".$M, PEAR_LOG_INFO);
$N = $dataArray[15];
$l->log("Current values: N:".$N, PEAR_LOG_INFO);
$O = $dataArray[16];
$l->log("Current values: O:".$O, PEAR_LOG_INFO);
$P = $dataArray[17];
$l->log("Current values: P:".$P, PEAR_LOG_INFO);
$Q = $dataArray[18];
$l->log("Current values: Q:".$Q, PEAR_LOG_INFO);
$R = $dataArray[19];
$l->log("Current values: R:".$R, PEAR_LOG_INFO);
$S = $dataArray[20];
$l->log("Current values: S:".$S, PEAR_LOG_INFO);

//Log the raw sms and exit if reportName and phoneNum are null.
if ($reportName == NULL || $phoneNum == NULL ) {
	$l->log("Incorrect values processed . $data:".$data, PEAR_LOG_ERR);
	echo "Unable to process the report.\n";
	exit("Incorrect report format for reportName:".$reportName." phoneNum:".$phoneNum);
}

$options = array(
"indent"          => "    ",
"linebreak"       => "\n",
"typeHints"       => false,
"addDecl"         => true,
"encoding"        => "UTF-8",
"rootName"        => "data",
"rootAttributes"  => array("id" => $reportName, "prefix" => $reportName, "delimeter" => "|"),
"attributesArray" => "_attributes"
);

$serializer = new XML_Serializer($options);

if ($reportName == "weeklyReportCommon") {

	$output =  array (
	"handset_id" => $deviceId,
	"Weekly_Clinical_malaria_under_5_years"  => $A,
	"Weekly_Clinical_malaria_5_years_and_over" => $B,
	"Weekly_Mal_lab_test" => $C,
	"Weekly_Mal_lab_test_pos" => $D,
	"Weekly_Clinical_malaria_death_under_5_years" => $E,
	"Weekly_Clinical_malaria_death_5_years_and_over" => $F,
	"Weekly_Diarrhoea_case_under_5_years" => $G,
	"Weekly_Diarrhoea_case_5_years_and_over" => $H,
	"Weekly_Diarrhoea_lab_test" => $I,
	"Weekly_Diarrhoea_lab_test_pos" => $J,
	"Weekly_Diarrhoea_death_under_5_years" => $K,
	"Weekly_Diarrhoea_death_5_years_and_over" => $L,
	"Weekly_Dysentery_under_5" => $M,
	"Weekly_Dysentery_5_years_and_over" => $N,
	"Weekly_Dysentery_death" => $O,
	"Weekly_Influenza_under_5" => $P,
	"Weekly_Influenza_5_and_over" => $Q,
	"Weekly_Influenza_death" => $R,
	"sms" => true,
	);

} else if ($reportName == "weeklyReportUncommon"){

	$output =  array (
	"handset_id" => $deviceId,
	"Weekly_Bites_dogs"  => $A,
	"Weekly_Bites_Other_animals" => $B,
	"Weekly_Cholera_under_5" => $C,
	"Weekly_Cholera_5_years_and_over" => $D,
	"Weekly_Cholera_Death" => $E,
	"Weekly_Measles_under_5" => $F,
	"Weekly_Measles_5_and_over" => $G,
	"Weekly_Measles_death" => $H,
	"Weekly_Acute_Flacid_Paralysis_under_5_years" => $I,
	"Weekly_Acute_Flacid_Paralysis_5_and_over" => $J,
	"Weekly_Acute_Flacid_Paralysis_death" => $K,
	"Weekly_Anthrax" => $L,
	"Weekly_Anthrax_Death" => $M,
	"Weekly_Haem_Fever_or_Ebola" => $N,
	"Weekly_Haem_Fever_or_Ebola_death" => $O,
	"Weekly_Plague" => $P,
	"Weekly_Plague_death" => $Q,
	"Weekly_Rabies" => $R,
	"Weekly_Neonatal_Tetanus" => $S,
	"sms" => true,
	);

} else {
	$l->log("Incorrect form: . $data:".$data, PEAR_LOG_ERR);
	exit("Incorrect form. You sent a report from " .$reportName . " You may SMS reports only for weeklyReportCommon and weeklyReportUncommon.");
}

$result = $serializer->serialize($output);

if( $result === true ) {
$serXml =  $serializer->getSerializedData();
} else {
echo "Failed to serialize the XML: " + $output;
}

$url = "http://yoursite.appspot.com/submission";

$c = curl_init($url);
curl_setopt($c, CURLOPT_POST, 1);
curl_setopt($c, CURLOPT_POSTFIELDS, $serXml);
curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);
$repsonse = trim( curl_exec($c) );
// $l->log("repsonse:".$repsonse, PEAR_LOG_INFO);
// If there is an error, replace the return value with details of the error
// echo "Result: " . $repsonse;
if ($repsonse === false) {
$error = curl_error($c);
echo "Error: " . $repsonse . " curl: ". $error;
} else {
echo "The report (".$reportName. ") from ". $phoneNum." was processed successfully.";
}
curl_close($c);

?>
